package com.jenny.compressedblocks;

import com.mojang.logging.LogUtils;
import net.minecraft.client.Minecraft;
import net.minecraft.core.registries.Registries;
import net.minecraft.network.chat.Component;
import net.minecraft.world.item.*;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.material.MapColor;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.server.ServerStartingEvent;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.ModLoadingContext;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.config.ModConfig;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.RegistryObject;
import org.slf4j.Logger;

// The value here should match an entry in the META-INF/mods.toml file
@Mod(CompressedBlocks.MODID)
public class CompressedBlocks
{
    // Define mod id in a common place for everything to reference
    public static final String MODID = "compressedblocks";
    // Directly reference a slf4j logger
    private static final Logger LOGGER = LogUtils.getLogger();
    // Create a Deferred Register to hold Blocks which will all be registered under the "examplemod" namespace
    public static final DeferredRegister<Block> BLOCKS = DeferredRegister.create(ForgeRegistries.BLOCKS, MODID);
    // Create a Deferred Register to hold Items which will all be registered under the "examplemod" namespace
    public static final DeferredRegister<Item> ITEMS = DeferredRegister.create(ForgeRegistries.ITEMS, MODID);
    // Create a Deferred Register to hold CreativeModeTabs which will all be registered under the "examplemod" namespace
    public static final DeferredRegister<CreativeModeTab> CREATIVE_MODE_TABS = DeferredRegister.create(Registries.CREATIVE_MODE_TAB, MODID);

    /* COBBLESTONE */

    public static final RegistryObject<Block> COBBLESTONE_1X = BLOCKS.register("cobblestone_1x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(2.0F, 8.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> COBBLESTONE_1X_ITEM = ITEMS.register("cobblestone_1x", () -> new BlockItem(COBBLESTONE_1X.get(), new Item.Properties()));

    public static final RegistryObject<Block> COBBLESTONE_2X = BLOCKS.register("cobblestone_2x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(3.0F, 9.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> COBBLESTONE_2X_ITEM = ITEMS.register("cobblestone_2x", () -> new BlockItem(COBBLESTONE_2X.get(), new Item.Properties()));

    public static final RegistryObject<Block> COBBLESTONE_3X = BLOCKS.register("cobblestone_3x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(4.0F, 10.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> COBBLESTONE_3X_ITEM = ITEMS.register("cobblestone_3x", () -> new BlockItem(COBBLESTONE_3X.get(), new Item.Properties()));

    public static final RegistryObject<Block> COBBLESTONE_4X = BLOCKS.register("cobblestone_4x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(5.0F, 11.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> COBBLESTONE_4X_ITEM = ITEMS.register("cobblestone_4x", () -> new BlockItem(COBBLESTONE_4X.get(), new Item.Properties()));

    /* ANDESITE */

    public static final RegistryObject<Block> ANDESITE_1X = BLOCKS.register("andesite_1x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(2.0F, 8.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> ANDESITE_1X_ITEM = ITEMS.register("andesite_1x", () -> new BlockItem(ANDESITE_1X.get(), new Item.Properties()));

    public static final RegistryObject<Block> ANDESITE_2X = BLOCKS.register("andesite_2x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(3.0F, 9.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> ANDESITE_2X_ITEM = ITEMS.register("andesite_2x", () -> new BlockItem(ANDESITE_2X.get(), new Item.Properties()));

    public static final RegistryObject<Block> ANDESITE_3X = BLOCKS.register("andesite_3x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(4.0F, 10.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> ANDESITE_3X_ITEM = ITEMS.register("andesite_3x", () -> new BlockItem(ANDESITE_3X.get(), new Item.Properties()));

    public static final RegistryObject<Block> ANDESITE_4X = BLOCKS.register("andesite_4x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(5.0F, 11.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> ANDESITE_4X_ITEM = ITEMS.register("andesite_4x", () -> new BlockItem(ANDESITE_4X.get(), new Item.Properties()));


    /* DIORITE */

    public static final RegistryObject<Block> DIORITE_1X = BLOCKS.register("diorite_1x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(2.0F, 8.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> DIORITE_1X_ITEM = ITEMS.register("diorite_1x", () -> new BlockItem(DIORITE_1X.get(), new Item.Properties()));

    public static final RegistryObject<Block> DIORITE_2X = BLOCKS.register("diorite_2x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(3.0F, 9.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> DIORITE_2X_ITEM = ITEMS.register("diorite_2x", () -> new BlockItem(DIORITE_2X.get(), new Item.Properties()));

    public static final RegistryObject<Block> DIORITE_3X = BLOCKS.register("diorite_3x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(4.0F, 10.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> DIORITE_3X_ITEM = ITEMS.register("diorite_3x", () -> new BlockItem(DIORITE_3X.get(), new Item.Properties()));

    public static final RegistryObject<Block> DIORITE_4X = BLOCKS.register("diorite_4x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(5.0F, 11.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> DIORITE_4X_ITEM = ITEMS.register("diorite_4x", () -> new BlockItem(DIORITE_4X.get(), new Item.Properties()));

    /* GRANITE */

    public static final RegistryObject<Block> GRANITE_1X = BLOCKS.register("granite_1x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(2.0F, 8.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> GRANITE_1X_ITEM = ITEMS.register("granite_1x", () -> new BlockItem(GRANITE_1X.get(), new Item.Properties()));

    public static final RegistryObject<Block> GRANITE_2X = BLOCKS.register("granite_2x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(3.0F, 9.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> GRANITE_2X_ITEM = ITEMS.register("granite_2x", () -> new BlockItem(GRANITE_2X.get(), new Item.Properties()));

    public static final RegistryObject<Block> GRANITE_3X = BLOCKS.register("granite_3x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(4.0F, 10.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> GRANITE_3X_ITEM = ITEMS.register("granite_3x", () -> new BlockItem(GRANITE_3X.get(), new Item.Properties()));

    public static final RegistryObject<Block> GRANITE_4X = BLOCKS.register("granite_4x", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(5.0F, 11.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> GRANITE_4X_ITEM = ITEMS.register("granite_4x", () -> new BlockItem(GRANITE_4X.get(), new Item.Properties()));

    /* COMBINED BLOCKS */

    public static final RegistryObject<Block> CBLOCK_MINING = BLOCKS.register("cblock_mining", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.NONE).strength(5.0F, 11.0F).requiresCorrectToolForDrops()));
    public static final RegistryObject<Item> CBLOCK_MINING_ITEM = ITEMS.register("cblock_mining", () -> new BlockItem(CBLOCK_MINING.get(), new Item.Properties()));

    // Creates a creative tab with the id "examplemod:example_tab" for the example item, that is placed after the combat tab
    public static final RegistryObject<CreativeModeTab> EXAMPLE_TAB = CREATIVE_MODE_TABS.register("compressed_blocks", () -> CreativeModeTab.builder()
            .withTabsBefore(CreativeModeTabs.COMBAT)
            .icon(() -> COBBLESTONE_1X_ITEM.get().getDefaultInstance())
            .title(Component.translatable("Compressed Blocks"))
            .displayItems((parameters, output) -> {
                output.accept(COBBLESTONE_1X.get());
                output.accept(COBBLESTONE_2X.get());
                output.accept(COBBLESTONE_3X.get());
                output.accept(COBBLESTONE_4X.get());
                output.accept(ANDESITE_1X.get());
                output.accept(ANDESITE_2X.get());
                output.accept(ANDESITE_3X.get());
                output.accept(ANDESITE_4X.get());
                output.accept(DIORITE_1X.get());
                output.accept(DIORITE_2X.get());
                output.accept(DIORITE_3X.get());
                output.accept(DIORITE_4X.get());
                output.accept(GRANITE_1X.get());
                output.accept(GRANITE_2X.get());
                output.accept(GRANITE_3X.get());
                output.accept(GRANITE_4X.get());
                output.accept(CBLOCK_MINING.get());
                output.accept(Tools.ULTRA_PICKAXE.get());
            }).build());

    public CompressedBlocks()
    {
        IEventBus modEventBus = FMLJavaModLoadingContext.get().getModEventBus();

        modEventBus.addListener(this::commonSetup);
        BLOCKS.register(modEventBus);
        ITEMS.register(modEventBus);
        Tools.register(modEventBus);

        CREATIVE_MODE_TABS.register(modEventBus);
        MinecraftForge.EVENT_BUS.register(this);
        ModLoadingContext.get().registerConfig(ModConfig.Type.COMMON, Config.SPEC);
    }

    private void commonSetup(final FMLCommonSetupEvent event)
    {
        // Some common setup code
        LOGGER.info("HELLO FROM COMMON SETUP");

        if (Config.logDirtBlock)
            LOGGER.info("DIRT BLOCK >> {}", ForgeRegistries.BLOCKS.getKey(Blocks.DIRT));

        LOGGER.info(Config.magicNumberIntroduction + Config.magicNumber);

        Config.items.forEach((item) -> LOGGER.info("ITEM >> {}", item.toString()));
    }

    // You can use SubscribeEvent and let the Event Bus discover methods to call
    @SubscribeEvent
    public void onServerStarting(ServerStartingEvent event)
    {
        // Do something when the server starts
        LOGGER.info("HELLO from server starting");
    }

    // You can use EventBusSubscriber to automatically register all static methods in the class annotated with @SubscribeEvent
    @Mod.EventBusSubscriber(modid = MODID, bus = Mod.EventBusSubscriber.Bus.MOD, value = Dist.CLIENT)
    public static class ClientModEvents
    {
        @SubscribeEvent
        public static void onClientSetup(FMLClientSetupEvent event)
        {
            // Some client setup code
            LOGGER.info("HELLO FROM CLIENT SETUP");
            LOGGER.info("MINECRAFT NAME >> {}", Minecraft.getInstance().getUser().getName());
        }
    }
}
